{*****************************************************************}
{                                                                 }
{   EXAMPLE.PAS Shareware Version 2.00 Sample Portion of Code.    }
{   Program to access Buttons from a .DLL                         }
{   Must be distributed with SSEAPP2.EXE,SSEBUT2.DLL,EXAMPLE.RES  }
{   EXAMPLE.EXE,SSEVCR.EXE,README.WRI,VENDOR.TXT and FILE_ID.DIZ  }
{   Copyright (c) 1992-95 by Speyside Software Enterprises        }
{   All Rights Reserved.                                          }
{                                                                 }
{   Speyside Software Enterprises                                 }
{   11, Sellar Place,                                             }
{   Aberlour On Spey,                                             }
{   Banffshire,                                                   }
{   AB38 9LE,                                                     }
{   Scotland.                                                     }
{                                                                 }
{ This program is provided to assist you to use the buttons       }
{ that are included in the .dll file SSEBUT2.DLL it will be of no }
{ use to you if you are an expert and can already load Custom     }
{ Control Buttons into your applications!                         }
{ NOTE: You will have to add your own procedures to process the   }
{       VCR type buttons also loaded by this program!             }
{*****************************************************************}

program ExampleApp;

{$R Example.RES}

uses WinTypes, WinProcs, WObjects;

const
  DLLName = 'SSEBUT2.DLL';

const
  em_DLLNotFound = 1;
  id_Help     = 190;
  id_About    = 210;
  id_Register = 220;

type
  PSSEWindow = ^TSSEWindow;
  TSSEWindow = object(TDlgWindow)
    procedure Ok(var Msg: TMessage);
      virtual id_First + id_OK;
    procedure Cancel(var Msg: TMessage);
      virtual id_First + id_Cancel;
    procedure Help(var Msg: TMessage);
      virtual id_First + id_Help;
    procedure SetUpWindow; virtual;
    procedure About(var Msg: TMessage); virtual id_First + id_About;
    procedure Reg(var Msg: TMessage); virtual id_First + id_Register;
end;

  PSSEApp = ^TSSEApp;
  TSSEApp = object(TApplication)
    Lib: THandle;
    constructor Init(AName: PChar);
    destructor Done; virtual;
    procedure InitMainWindow; virtual;
    procedure Error(ErrorCode: Integer); virtual;
  end;

{ TSSEApp }
constructor TSSEApp.Init(AName: PChar);
begin
  Lib := LoadLibrary(DLLName);
  if Lib < 32 then Status := em_DLLNotFound;
  TApplication.Init(AName);
end;

destructor TSSEApp.Done;
begin
  TApplication.Done;
  FreeLibrary(Lib);
end;

procedure TSSEApp.InitMainWindow;
begin
  MainWindow := New(PSSEWindow, Init(nil, MakeIntResource(100)));
end;

procedure TSSEApp.Error(ErrorCode: Integer);
begin
  case ErrorCode of
    em_DLLNotFound:
      MessageBox(0, DLLName + ' not found. Please compile The Library' +
        'before executing this application.', 'Fatal error',
        mb_Ok or mb_IconStop);
  else
    TApplication.Error(ErrorCode);
  end;
end;

{ TSSE Window }
procedure TSSEWindow.Ok(var Msg: TMessage);
begin
  CloseWindow;
end;

procedure TSSEWindow.Cancel(var Msg: TMessage);
begin
  CloseWindow;
end;

 procedure TSSEWindow.Help(var Msg: TMessage);
  begin
  MessageBox(0, 'Enter code to call Help routine here!', 'Example Help',
  mb_TaskModal or mb_IconInformation);
  end;

procedure TSSEWindow.SetUpWindow;
var
    Dialog: TDialog;
   begin
     Dialog.Init(@Self, 'About');
     Dialog.Execute;
     Dialog.Done;
  end;

procedure TSSEWindow.About(var Msg: TMessage);
 var
    Dialog: TDialog;
   begin
     Dialog.Init(@Self, 'About');
     Dialog.Execute;
     Dialog.Done;
  end;
 procedure TSSEWindow.Reg(var Msg: TMessage);
  begin
  MessageBox(0, 'Enter code for registration routine here!', 'Example Register',
  mb_TaskModal or mb_IconInformation);
  end;

var
  App: TSSEApp;

begin
  App.Init('SSEApp');
  App.Run;
  App.Done;
end.
